uuid: 84e43770-2fca-41c6-bc3c-0774d01a7f49
langcode: en
status: true
dependencies: {  }
id: upgrade_d7_field_instance_widget_settings
class: Drupal\migrate_drupal\Plugin\migrate\FieldMigration
field_plugin_method: alterFieldWidgetMigration
cck_plugin_method: null
migration_tags:
  - 'Drupal 7'
  - Configuration
migration_group: migrate_drupal_7
label: 'Field instance widget configuration'
source:
  plugin: d7_field_instance_per_form_display
  constants:
    form_mode: default
    third_party_settings: {  }
process:
  field_type_exists:
    -
      plugin: migration_lookup
      migration: upgrade_d7_field
      source:
        - field_name
        - entity_type
    -
      plugin: extract
      index:
        - 0
    -
      plugin: skip_on_empty
      method: row
  bundle:
    0:
      plugin: static_map
      source: bundle
      bypass: true
      map:
        comment_node_forum: comment_forum
    paragraphs:
      plugin: paragraphs_process_on_value
      source_value: entity_type
      expected_value: field_collection_item
      process:
        plugin: substr
        start: 6
  form_mode:
    -
      plugin: get
      source: constants/form_mode
  field_name:
    -
      plugin: get
      source: field_name
  entity_type:
    0:
      plugin: get
      source: entity_type
    paragraphs:
      plugin: static_map
      map:
        field_collection_item: paragraph
        paragraphs_item: paragraph
      bypass: true
  options/weight:
    -
      plugin: get
      source: widget/weight
  widget_type:
    -
      plugin: process_field
      source: type
      method: getFieldWidgetType
  options/type:
    type:
      plugin: static_map
      bypass: true
      source: '@widget_type'
      map:
        link_field: link_default
        email_textfield: email_default
        date_select: datetime_default
        date_text: datetime_default
        date_popup: datetime_default
        media_generic: file_generic
        phone_textfield: telephone_default
        options_onoff: boolean_checkbox
        entityreference_autocomplete: entity_reference_autocomplete
        entityreference_autocomplete_tags: entity_reference_autocomplete_tags
        taxonomy_autocomplete: entity_reference_autocomplete
        d7_text: d7_text_default
        list: list_default
        date: datetime_default
        datetime: datetime_default
        datestamp: datetime_timestamp
        taxonomy_term_reference: taxonomy_term_reference_default
        paragraphs_embed: entity_reference_paragraphs
        paragraphs: paragraphs_default
        entityreference: entityreference_default
        filefield_widget: file_generic
        color_field_default_widget: color_field_widget_box
        color_field_simple_widget: color_field_widget_grid
        color_field_spectrum_widget: color_field_widget_html5
        color_field_plain_text: color_field_widget_default
        field_collection_embed: entity_reference_paragraphs
        field_collection: field_collection_default
        number_default: number_default_default
        image: image_default
  options/settings:
    -
      plugin: field_instance_widget_settings
      source:
        - widget/type
        - widget/settings
  options/third_party_settings:
    -
      plugin: get
      source: constants/third_party_settings
  options/settings/title:
    paragraphs:
      plugin: paragraphs_process_on_value
      source_value: type
      expected_value: paragraphs
      process:
        plugin: get
        source: settings/title
  options/settings/title_plural:
    paragraphs:
      plugin: paragraphs_process_on_value
      source_value: type
      expected_value: paragraphs
      process:
        plugin: get
        source: settings/title_multiple
  options/settings/edit_mode:
    paragraphs:
      plugin: paragraphs_process_on_value
      source_value: type
      expected_value: paragraphs
      process:
        plugin: get
        source: settings/default_edit_mode
  options/settings/add_mode:
    paragraphs:
      plugin: paragraphs_process_on_value
      source_value: type
      expected_value: paragraphs
      process:
        plugin: get
        source: settings/add_mode
destination:
  plugin: component_entity_form_display
migration_dependencies:
  required:
    - upgrade_d7_field_instance
  optional:
    - upgrade_d7_field_collection_type
    - upgrade_d7_paragraphs_type
    - upgrade_d7_field
